'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PluralRules = _interopDefault(require('./plural-rules'));

if (typeof Intl === 'undefined') {
  if (typeof global !== 'undefined') {
    global.Intl = {
      PluralRules: PluralRules
    };
  } else if (typeof window !== 'undefined') {
    window.Intl = {
      PluralRules: PluralRules
    };
  } else {
    this.Intl = {
      PluralRules: PluralRules
    };
  }

  PluralRules.polyfill = true;
} else if (!Intl.PluralRules) {
  Intl.PluralRules = PluralRules;
  PluralRules.polyfill = true;
} else {
  var test = ['en', 'es', 'ru', 'zh'];
  var supported = Intl.PluralRules.supportedLocalesOf(test);

  if (supported.length < test.length) {
    Intl.PluralRules = PluralRules;
    PluralRules.polyfill = true;
  }
}
